﻿@using System.Web.UI.WebControls
@using Kendo.Mvc.UI
@model FMS.Models.ViewModels.ServiceToMembershipViewModel

<div class="form shadowed">

@Html.Partial("_FormHeader")

<div class="form-body">

@{ Html.RenderPartial("_Alerts"); }

    <div class="panel panel-default">

    <div class="panel-body">

    <div class="form-horizontal">
                        
    @Html.HiddenFor(model => model.MembershipService.MembershipId)
    
        <input id="MembershipId" type="hidden" name="MembershipId" value="@ViewBag.MembershipId" />

    <div class="form-group">
        @Html.LabelFor(model => model.MembershipService.BusinessServiceGroupId, new { @class = "control-label col-md-3" })
        <div class="col-md-9">

            @(Html.Kendo().DropDownListFor(model => model.MembershipService.BusinessServiceGroupId)
                  .Name("BusinessServiceGroupId")
                  .DataTextField("Name")
                  .DataValueField("Id")
                  .Filter("contains")
                  .Events(e => { e.Change("onChange"); })
                  .CascadeFrom("MembershipId")
                  //.DataSource(source => source.Read(read => read.Action("LongNameToCombo", "BusinessServices").Data("filterProducts")))
                  .DataSource(source =>
                  {
                      source.Read(read =>
                      {
                          read.Action("LongNameToComboByMembership", "BusinessServiceGroups")
                              .Data("filterProducts");
                      })
                      .ServerFiltering(false);
                  })
                  .HtmlAttributes(new { style = "width: 100%;", title = "Hizmet", PlaceHolder = "Hizmet Seçiniz...", required = true })
                  .Events(e => e.DataBound("businessServiceOnDataBound"))
              )
            <script>
                function filterProducts() {
                    return {
                        membershipId: $("#MembershipId").val()
                    };
                }
            </script>

            @Html.ValidationMessageFor(model => model.MembershipService.BusinessServiceGroupId, "", new { @class = "text-danger" })

        </div>
    </div>
        
    @*<div class="form-group">
        @Html.Label("Hizmet Tutarı", new { @class = "control-label col-md-3" })
        <div class="col-md-3">

            <input id="Amount" type="number" class="form-control" disabled="disabled" />

        </div>
    </div>*@

    <div class="form-group">
        @Html.LabelFor(model => model.MembershipService.Amount, new { @class = "control-label col-md-3" })
        <div class="col-md-3">

            @(Html.Kendo().NumericTextBoxFor(model => model.MembershipService.Amount)
                        .Name("Amount")
                        .Culture("tr-TR")
                        //.Round(false)
                        .Min(0)
                        .Spinners(false)
                        .Format("#.##").Decimals(20)
                        //.Step(1)
                        //.Min(1)
                        //.Max(60)
                        //.Format("0")
                        //.Decimals(2)
                        .HtmlAttributes(new { style = "width: 100%;", title = "Hizmet Tutarı", placeholder = "Hizmet Tutarı giriniz...", required = true }))


            @Html.ValidationMessageFor(model => model.MembershipService.Amount, "", new { @class = "text-danger" })

        </div>
    </div>
        
    @*<div class="form-group">
        @Html.Label("Maksimum Taksit Sayısı", new { @class = "control-label col-md-3" })
        <div class="col-md-1">

            <input id="maxInterval" type="number" class="form-control" disabled="disabled" />

        </div>
    </div>*@

    <div class="form-group">
        @Html.Label("Ödemesiz mi?", new { @class = "control-label col-md-3" })
        <div class="col-md-1">

            <input id="isFree" type="checkbox"  onclick="return false;" />

        </div>
    </div>


    <div class="form-group">
        @Html.LabelFor(model => model.MembershipService.ApplicationDate, new { @class = "control-label col-md-3" })
        <div class="col-md-3">

            @(Html.Kendo().DatePickerFor(model => model.MembershipService.ApplicationDate)
                        .Name("ApplicationDate")
                        .Format("dd.MM.yyyy")
                        .Culture("tr-TR")
                        .Value(DateTime.Now)
                        .HtmlAttributes(new { style = "width: 100%;", title = "İşlem Tarihi", placeholder = "İşlem Tarihi seçiniz ...", required = true })
                        .Events(e =>
                        {
                            e.Change("applicationDateChange");
                        }))


            @Html.ValidationMessageFor(model => model.MembershipService.ApplicationDate, "", new { @class = "text-danger" })

        </div>
    </div>


    <div class="form-group">
        @Html.LabelFor(model => model.MembershipService.ReferenceCode, new { @class = "control-label col-md-3" })
        <div class="col-md-9">

            @(Html.Kendo().AutoCompleteFor(model => model.MembershipService.ReferenceCode)
                    .Name("ReferenceCode")
                    .DataTextField("ReferenceCode")
                    .Placeholder("Referans Kodu giriniz ...")
                    .Filter("contains")
                    .DataSource(source => source.Read(read => read.Action("ReferenceCodeToComplete", "MembershipServices")))
                    .HtmlAttributes(new { style = "width: 100%;", title = "Referans Kodu"}))


            @Html.ValidationMessageFor(model => model.MembershipService.ReferenceCode, "", new { @class = "text-danger" })

        </div>
    </div>

    <div class="form-group">
        @Html.Label("Hizmet Notu", new { @class = "control-label col-md-3" })
        <div class="col-md-9">

            @(Html.Kendo().TextBox()
                .Name("MembershipServiceNote")
                .HtmlAttributes(new { style = "width: 100%;", title = "Not", placeholder = "Not giriniz ..." }))


            @Html.ValidationMessage("MembershipServiceNote", "", new { @class = "text-danger" })

        </div>
    </div>
                        
    <hr/>

    


    <div class="form-group">

        @Html.Label("Üyenin Borçları", new { @class = "control-label col-md-3" })

        <div class="col-md-9">

            <table class="table table-responsive table-bordered table-striped">

                <tr>
                    <th style="text-align: center;">Seç</th>
                    <th style="text-align: center;">Vade Tarihi</th>
                    <th style="text-align: left;">Borç Tipi</th>
                    <th style="text-align: right;">Tutar</th>
                </tr>

                @for (var i = 0; i < Model.Transactions?.Count; i++)
                {
                    var transactionId = Model.Transactions[i].Id;
                    <tr>
                        @Html.Hidden("TransactionId"+i, transactionId)
                        
                        <td style="text-align: center">
                            @Html.CheckBoxFor(model => Model.Transactions[i].IsChecked, new { id = "IsChecked" + i, @class = "chkclass", value = Model.Transactions[i].BalanceSigned })
                            @Html.HiddenFor(model => model.Transactions[i].Id)
                        </td>
                        <td style="text-align: center;">@Html.DisplayFor(model => Model.Transactions[i].MaturityDate, "ShortDate")</td>
                        <td style="text-align: left;">@Html.DisplayFor(model => Model.Transactions[i].DebitTypeName)</td>
                        <td style="text-align: right;">@Html.DisplayFor(model => Model.Transactions[i].BalanceSigned, new { id = "BalanceSigned", @class = "amount" })</td>
                    </tr>
                }

                <tr>
                    <th colspan="3" style="text-align: right; ">Kesilecek Tutar</th>
                    <th style="text-align: right; color:red ">
                        <div id="sum"></div>
                    </th>
                </tr>
                <tr>
                    <th colspan="3" style="text-align: right; ">Ödenecek Tutar</th>
                    <th style="text-align: right; color:green " >
                        <div id="totalCredit"></div>
                    </th>
                </tr>

            </table>

        </div>
    </div>

    

    <div id="paymentPlanGroup">

        <hr />

        <div class="form-group">
            @*@Html.Label("Localized_Column_Name", new { @class = "col-md-2 caption text-left" })*@
            @Html.Label("Geri Ödeme Günü", new { @class = "control-label col-md-3" })
            <div class="col-md-8">

                @(Html.Kendo().NumericTextBoxFor(model => model.Membership.PaymentDay)
                        .Name("PaymentDay")
                        .Decimals(0)
                        //.Spinners(false)
                        //.Culture("tr-TR")
                        .Format("##")
                        .Step(1)
                        .Min(1)
                        .Max(31)
                        .HtmlAttributes(new { style = "width: 9%;", title = "Ödeme Günü" }))

                @Html.ValidationMessageFor(model => model.Membership.PaymentDay, "", new { @class = "text-danger" })

            </div>
        </div>



        <div class="form-group">
            @Html.LabelFor(model => model.MembershipService.ActivationDate, new { @class = "control-label col-md-3" })
            <div class="col-md-3">

                @(Html.Kendo().DatePickerFor(model => model.MembershipService.ActivationDate)
                            .Name("ActivationDate")
                            .Start(CalendarView.Year)
                            .Depth(CalendarView.Year)
                            .Format("MM.yyyy")
                            .Culture("tr-TR")
                            .Value(DateTime.Now.AddMonths(1))
                            .DateInput()
                            .HtmlAttributes(new { style = "width: 100%", title = "monthpicker", placeholder = "Ödeme Başlangıç Ayı ..." })
                            .Events(e =>
                            {
                                e.Change("activationDateChange");
                            }))

                @*@(Html.Kendo().DatePickerFor(model => model.MembershipService.ActivationDate)
                .Name("ActivationDate")
                .Format("dd.MM.yyyy")
                .Culture("tr-TR")
                .HtmlAttributes(new {style = "width: 100%;", title = "Ödeme Başlangıcı", placeholder = "Ödeme Başlangıcı seçiniz ...", required = true}))*@


                @Html.ValidationMessageFor(model => model.MembershipService.ActivationDate, "", new { @class = "text-danger" })

            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ServicePayment.TransactionTypeId, new { @class = "control-label col-md-3" })
            <div class="col-md-9">

                @(Html.Kendo().DropDownListFor(model => model.ServicePayment.TransactionTypeId)
                .Name("TransactionTypeId")
                .DataTextField("Name")
                .DataValueField("Id")
                .Filter("contains")
                .DataSource(source => source.Read(read => read.Action("NameToCombo", "TransactionTypes")))
                .HtmlAttributes(new { style = "width: 100%;", title = "İşlem Tipi", required = true }))


                @Html.ValidationMessageFor(model => model.ServicePayment.TransactionTypeId, "", new { @class = "text-danger" })

            </div>
        </div>

        <div class="form-group">
            @Html.Label("Geri Ödeme Taksit Sayısı", new { @class = "control-label col-md-3" })
            <div class="col-md-2">

                <input id="planInterval" type="number" class="form-control" disabled="disabled" />
                <input id="tempText" type="hidden" class="form-control" hidden="hidden" />

            </div>
            <div class="col-md-2">

                <input id="createPlan" type="button" class="btn btn-primary" value="Oluştur" disabled="disabled" />

            </div>
        </div>

        <div class="form-group">

            @Html.Label("Geri Ödeme Planı", new { @class = "control-label col-md-3" })

            <div class="col-md-9">

                <table id="NewInvoiceTable" class="table table-responsive table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Seç</th>
                            <th>Vade Tarihi</th>
                            <th>Tutar</th>
                        </tr>
                    </thead>
                    <tbody class="paymentPlan"></tbody>
                    <tr>
                        <th colspan="3">
                            <input type="button" class="add-row btn btn-default" value="Ekle">
                            <input type="button" class="delete-row btn btn-default" value="Sil">
                        </th>
                    </tr>
                    <tr>
                        <th colspan="2" style="text-align: right;">
                            <div>Toplam Tutar</div>

                        </th>
                        <th colspan="1" style="text-align: left; color:green"><div id="installmentTotal"></div></th>


                    </tr>
                </table>

            </div>
        </div>

        <div class="form-group">
            @Html.Label("Geri Ödeme Notu", new { @class = "control-label col-md-3" })
            <div class="col-md-9">

                @(Html.Kendo().TextBox()
                .Name("ServicePaymentNote")
                .HtmlAttributes(new { style = "width: 100%;", title = "Not", placeholder = "Not giriniz ..." }))


                @Html.ValidationMessage("ServicePaymentNote", "", new { @class = "text-danger" })

            </div>
        </div>

        <hr />

    </div>
    

    

    

    </div>

    </div>

    </div>

    <br />

    <div class="row">

        <div class="col-md-12 text-left">

            <input id="check" type="checkbox" required /> Üyelik Hizmetini Oluştur <br /><br />

            @Html.ActionLink(" ", "IndexByMembership", "MembershipServices", new { membershipId = ViewBag.MembershipId }, new { @class = "btn btn-default icon-arrow-back", title = "Geri" })

            @*<button id="btnSave" type="button" name="submit" value="submit" class="btn btn-default icon-save" title="Üyelik hizmetini oluştur"></button>*@
            <input type="button" name="button" formnovalidate value="submit" id="btnSave" class="btn btn-primary" />
            @*<input id="submit" type="button" name="submit" class="btn btn-default icon-save" title="Üyelik hizmetini oluştur" />*@

        </div>

    </div>


</div>

</div>




<script type='text/javascript'>
    $('#btnSave2').click(function (e) {
        e.preventDefault();

        BootstrapDialog.confirm({
            // omitted
            callback: function (result) {
                if (result) {
                    // whatever code you want to run on callback
                    // to submit the form
                    // $("#idOfForm").submit();
                    test();
                }
                else {
                    $("#ServicePaymentNote").val("");
                }
            }
        });
    });

    function test() {

        $("#ServicePaymentNote").val("Test");

    };

    $('#btnSave').click(function (e) {

        var membershipId = $("#MembershipId").val();
        var arrayTransactionId = [];
        var arrayTransactionAmount = [];
        var count = 0;
        $('.chkclass:checked').each(function () {

            var newValue = parseFloat($(this).val());
            var transactionId = $("#TransactionId" + count).val();

            arrayTransactionId.push(transactionId);
            arrayTransactionAmount.push(newValue);

            count++;

        });



        var arrayPaymentPlanDebit = [];
        var arrayPaymentPlanDate = [];
        var installmentCount = 0;
        var isExeedFromValidDate = false;
        var exeedDate = new Date();

        var strValidApplicationDate = $("#ApplicationDate").val();
        var formatValid = strValidApplicationDate.split(".");
        var validApplicationDate = new Date(formatValid[2], formatValid[1] - 1, formatValid[0]);


        var maxInterval = $("#planInterval").val();
        var countOfMonth = validApplicationDate.getMonth();
        var maxInterval_Int = parseInt(maxInterval);
        validApplicationDate.setMonth(validApplicationDate.getMonth() + maxInterval_Int);
        var validAppDateStr = convertDate(validApplicationDate);



        var validApp_Month = validApplicationDate.getMonth() + 1;
        var validApp_Year = validApplicationDate.getFullYear();


        var amount = $("#Amount").val();
        var floatAmount = parseFloat(amount);

        if (floatAmount == "" || floatAmount <= 0) {
            BootstrapDialog.alert("Tutar Değeri Boş veya Sıfıra Olamaz.");
            return false;
        }



        var installmentSum = 0;


        //getMonth
        $(".paymentPlan").find('input[name="record"]').each(function () {

            var id = $(this).attr('id');

            if (id == null)
                return;


            var format = id.split("-");

            var nDebit = $("#nDebit-" + format[1]).val();
            var mDate = $("#mDate-" + format[1]).val();

            arrayPaymentPlanDebit.push(nDebit);
            arrayPaymentPlanDate.push(mDate);


            var formatMDate = mDate.split("-");
            var mDateValid = new Date(formatMDate[0], formatMDate[1] - 1, formatMDate[2]);


            var mDate_Month = mDateValid.getMonth() + 1;
            var mDate_Year = mDateValid.getFullYear();

            var floatDebit = parseFloat(nDebit);
            installmentSum += floatDebit;
            //
            //if (mDateValid >= validApplicationDate) {
            //    exeedDate = mDate;
            //    isExeedFromValidDate = true;
            //}

            if ((mDate_Year == validApp_Year && mDate_Month > validApp_Month) ||
                (mDate_Year > validApp_Year)) {

                exeedDate = mDate;
                isExeedFromValidDate = true;

            }
                

            installmentCount++;

        });

        
        var isFree = $('#isFree').is(":checked");//$("#isFree").val();
        if (installmentSum != amount && !isFree)
        {
            $("#installmentTotal").html(installmentSum);
            BootstrapDialog.alert("Hizmet Geri Ödemeli. Geri Ödeme Planı Yapılmamış. Taksit Toplamı ile Alınacak Tutar '" + amount + "' Eşit Olmalıdır.");
            return false;
        }



        var BusinessServiceGroupId = $("#BusinessServiceGroupId").val();
        var applicationDate = $("#ApplicationDate").val();
        var membershipServiceNote = $("#ReferenceCode").val();
        var activationDate = $("#ActivationDate").val();
        var transactionTypeId = $("#TransactionTypeId").val();
        var servicePaymentPlanNote = $("#Note").val();


        if (isExeedFromValidDate && !isFree) {

            // //BootstrapDialog.alert("Taksit Tarihi '" + exeedDate + "' ile Son Taksit Geçerli Tarihinden '" + validAppDateStr + "' Buyuk Olamaz.");
            // //return false;
            // e.preventDefault();
            // BootstrapDialog.confirm({
            //     // omitted
            //     callback: function(result) {
            //         if(!result) {
            //// whatever code you want to run on callback
            //// to submit the form
            //             return false;
            //         }
            //     }
            // });

            bootbox.prompt({
                title: "Taksit Tarihi '" + exeedDate + "' ile Son Taksit Geçerli Tarihinden '" + validAppDateStr + "' Buyuk Olamaz.",
                centerVertical: true,
                callback: function (result) {
                    if (result != null) {

                        $("#ServicePaymentNote").val(result.toString());

                        if (installmentCount == 0 && !isFree) {
                            BootstrapDialog.alert("Lütfen Ödeme Planı Yapınız.");
                            return false;
                        }

                        $.ajax({
                            //url: "/MembershipServices/CreateByViewModels",
                            type: 'POST',
                            cache: false,
                            contentType: 'application/json',
                            data: JSON.stringify({
                                mId: membershipId,
                                strAmount: floatAmount,
                                sId: $("#BusinessServiceGroupId").val(),
                                appDate: $("#ApplicationDate").val(),
                                refCode: $("#ReferenceCode").val(),
                                actDate: $("#ActivationDate").val(),
                                tranTypeId: $("#TransactionTypeId").val(),
                                membershipServiceNote: $("#MembershipServiceNote").val(),
                                servicePaymentNote: $("#ServicePaymentNote").val(),
                                arrayTransactionId: arrayTransactionId,
                                arrayTransactionAmount: arrayTransactionAmount,
                                arrayPaymentPlanDebit: arrayPaymentPlanDebit,
                                arrayPaymentPlanDate: arrayPaymentPlanDate,
                                installmentCount: installmentCount
                            }),
                            success: function (response) {

                                if (response.success) {
                                    window.location.href = "/MembershipServices/IndexByMembership?membershipId=" + membershipId;
                                }

                                BootstrapDialog.alert(response.responseText);

                            },
                            error: function (response) {
                                BootstrapDialog.alert("'Bir Hata Oluştu. İşlem Tamamlanmadı..");
                            }

                        });

                        return true;
                    }
                    else {
                        return false;
                    }
                }
            });
        }
        else {



            if (installmentCount == 0 && !isFree) {
                BootstrapDialog.alert("Lütfen Ödeme Planı Yapınız.");
                return false;
            }



            $.ajax({
                //url: "/MembershipServices/CreateByViewModels",
                type: 'POST',
                cache: false,
                contentType: 'application/json',
                data: JSON.stringify({
                    mId: membershipId,
                    strAmount: floatAmount,
                    sId: $("#BusinessServiceGroupId").val(),
                    appDate: $("#ApplicationDate").val(),
                    refCode: $("#ReferenceCode").val(),
                    actDate: $("#ActivationDate").val(),
                    tranTypeId: $("#TransactionTypeId").val(),
                    membershipServiceNote: $("#MembershipServiceNote").val(),
                    servicePaymentNote: $("#ServicePaymentNote").val(),
                    arrayTransactionId: arrayTransactionId,
                    arrayTransactionAmount: arrayTransactionAmount,
                    arrayPaymentPlanDebit: arrayPaymentPlanDebit,
                    arrayPaymentPlanDate: arrayPaymentPlanDate,
                    installmentCount: installmentCount
                }),
                success: function (response) {

                    if (response.success) {
                        window.location.href = "/MembershipServices/IndexByMembership?membershipId=" + membershipId;
                    }

                    BootstrapDialog.alert(response.responseText);

                },
                error: function (response) {
                    BootstrapDialog.alert("'Bir Hata Oluştu. İşlem Tamamlanmadı..");
                }

            });
        }


    });





    $('.chkclass').click(function () {

        var amount = $("#Amount").val();
        var sum = 0;
        $('.chkclass:checked').each(function () {


            var newValue = parseFloat($(this).val());
            sum += newValue;

            //
            if(sum > amount)
            {
                BootstrapDialog.alert('Toplam Börç (' + sum + ') Hizmet Tutarindan (' + amount + ') Daha Buyuk Olamaz');

                sum -= newValue;
                $(this).prop('checked', false);

            }
        });
        $('#sum').html(Math.round(sum * 100) / 100);

        sum = -1 * sum;
        var remain = amount - sum;
        remain = Math.round(remain * 100) / 100;

        $('#totalCredit').html(remain);
    });


    $('#NewInvoiceTableAddRow').click(function (event) {
        var tableID = "NewInvoiceTable";
        AddRow(tableID);
        return false;
    });




    function postParameter() {


        $.ajax({
            type: "POST",
            url: "/BusinessServiceGroups/AmountToCombo",
            data: '{serviceId: "' + $("#BusinessServiceGroupId").val() + '" }',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function (dataAmount) {
                $("#Amount").val(dataAmount.Amount);
            },
            failure: function (dataAmount) {
                alert(dataAmount.responseText);
            },
            error: function (dataAmount) {
                alert(dataAmount.responseText);
            }
        });

        $.ajax({
            type: "POST",
            url: "/BusinessServiceGroups/IntervalToCombo",
            data: '{serviceId: "' + $("#BusinessServiceGroupId").val() + '" }',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function (dataInterval) {

                // $("#maxInterval").val(dataInterval.MaxInterval);
                // $("#planInterval").val(dataInterval.planInterval);
                $("#isFree").prop('checked', dataInterval.IsFree);

                //
                if (dataInterval.IsFree)
                {
                    $("#paymentPlanGroup").hide();
                }
                else {
                    $("#paymentPlanGroup").show();
                }
                    

                $("#planInterval").prop("disabled", false);
                $("#createPlan").prop("disabled", false);
                $("#isFree").prop("disabled", false);
            },
            failure: function (dataInterval) {
                alert(dataInterval.responseText);
            },
            error: function (dataInterval) {
                alert(dataInterval.responseText);
            }
        });

    }

    function pos_to_neg(num) {
        return -Math.abs(num);
    }


    function businessServiceOnDataBound() {
        postParameter();
    }


    function onChange() {
        postParameter();
    }


    $('input.k-input.comboBox').each(function () {
        $(this).keyup(function (e) {

            var key = e.keyCode;

            // Backspace or Delete
            if (key == 8 || key == 46)
                return false;
        });
    });



    $("#ActivationDate").keypress(function(e){

        var key = e.keyCode;

        // Backspace or Delete
        if (key == 8 || key == 46)
            return false;

    });


    $("#ApplicationDate").keypress(function (e) {


        e = e || window.event;
        var charCode = (typeof e.which == "undefined") ? e.keyCode : e.which;
        var charStr = String.fromCharCode(charCode);
        if (charCode != "0" && !/\d/.test(charStr)) {
            return false;
        }

        var key = e.keyCode;

        // Backspace or Delete
        if (key == 8 || key == 46)
            return false;

    });

    //function AddRow(tableID,i) {


    //    var tableRow = '<tr>';
    //    tableRow += '<td><input type="checkbox" name="record" /></td>';
    //    tableRow += '<td><input type="date" name="maturityDate[]" id="mDate-' + i + ' " placeholder="Item Name" class="form-control"></td>';
    //    tableRow += '<td><input type="number" name="debit[]" id="nDebit-' + i + ' " placeholder="Item Price" class="form-control"></td>';
    //    tableRow += '</tr>';
    //    $('#' + tableID + ' tbody').append(tableRow);
    //}


    $("#planInterval").keypress(function (e) {

        e = e || window.event;
        var charCode = (typeof e.which == "undefined") ? e.keyCode : e.which;
        var charStr = String.fromCharCode(charCode);
        if (charCode != "0" && !/\d/.test(charStr)) {
            return false;
        }
    });


    $("#planInterval").keyup(function (e) {

        //var maxInterval = $("#maxInterval").val();
        //var planInterval = $("#planInterval").val();
        //var pi = parseInt(planInterval);
        //var mi = parseInt(maxInterval);
        ////
        //if(pi > mi)
        //{
        //    BootstrapDialog.alert("Ödeme Plan Taksit Sayısı '" + planInterval + "' ile Maksimum Taksit Sayısı '" + maxInterval + "' Daha Buyuk Olamaz!");
        //    $('#planInterval').val(maxInterval);
        //}

    });







    $("#createPlan").click(function () {

        $("#NewInvoiceTable").find('input[name="record"]').each(function () {
            $(this).parents("tr").remove();

        });


        //var maxInterval = $("#maxInterval").val();
        var count = $('#planInterval').val();
        var pi = parseInt(count);
        //var mi = parseInt(maxInterval);
        ////
        //if (pi > mi) {

        //    BootstrapDialog.alert("Ödeme Planı Taksit Sayısı '" + pi + "' íle Maksimum Taksit Sayısı '" + mi + "' Buyuk Olamaz!");
        //    return;
        //}



        var tableID = "NewInvoiceTable";
        var k = $('#NewInvoiceTable').length;
        //
        var amount = $("#Amount").val();
        var floatAmount = parseFloat(amount);
        var installment = parseInt(floatAmount / pi);
        //
        var actiovationDate = $("#ActivationDate").val();
        var stringDate = "01." + actiovationDate;
        var format = stringDate.split(".");
        var myDate = new Date(format[2], format[1] - 1, format[0]);
        var paymentDay = parseInt($("#PaymentDay").val());
        if (paymentDay.toString().trim() == "" || paymentDay.toString().trim() == "0") {
            $('#PaymentDay').val(1);
            paymentDay = 1;
        }


        //
        myDate.setDate(paymentDay);
        var month = myDate.getMonth() + 1;
        var sum = 0;
        //
        for (var i = 0; i < pi; i++) {

            var dTest = new Date(myDate.getFullYear(), myDate.getMonth(), paymentDay);

            var tableRow = '<tr>';
            tableRow += '<td><input id="chk-' + i + '"  type="checkbox" name="record" /></td>';
            tableRow += '<td><input type="date" name="maturityDate" id="mDate-' + i + '" onkeypress="dynamicDateKeyPress(event)" onkeyup="dynamicDateKeyUp(event)" placeholder="Item Name" class="form-control"></td>';
            tableRow += '<td><input type="number" name="debit[]" id="nDebit-' + i + '" placeholder="Item Price" class="form-control"></td>';
            tableRow += '</tr>';
            $('#NewInvoiceTable').append(tableRow);

            var last = count - 1;
            if (i == last)
                installment = floatAmount - sum;

            sum += parseInt(installment);

            dTest.setMonth(dTest.getMonth() + i);
            var strDate = convertDate(dTest);
            //
            var dateColumnName = "#mDate-" + i;
            var debitColumnName = "#nDebit-" + i;
            $(dateColumnName).val(strDate);
            $(debitColumnName).val(installment);

        }

        $('#installmentTotal').html(sum);

    });


    function dynamicDateKeyPress(event) {

        var inputId = event.currentTarget.id;
        var RowIndex = inputId.split('-')[1];
        var charCode = (typeof event.which == "undefined") ? event.keyCode : event.which;
        var d = $("#mDate-" + RowIndex).val();

        $("#tempText").val(d);

        //BootstrapDialog.alert("Keypress Test RowIndex = " + RowIndex.toString());

    }

    function dynamicDateKeyUp(event) {

        var inputId = event.currentTarget.id;
        var RowIndex = inputId.split('-')[1];
        var charCode = (typeof event.which == "undefined") ? event.keyCode : event.which;
        ////
        if ((charCode == 8 || charCode == 46) || (charCode != 8 && charCode != 46 && charCode != "0" && !/\d/.test(charStr))) {

            var d = $("#tempText").val();

            $("#mDate-" + RowIndex).val(d);
        }

        //BootstrapDialog.alert("Keypress Test RowIndex = " + RowIndex.toString());

    }

    $('#NewInvoiceTable').on('keypress', 'input', function (e) {




        //e = e || window.event;
        //var charCode = (typeof e.which == "undefined") ? e.keyCode : e.which;
        //var charStr = String.fromCharCode(charCode);
        //var inputId = $(this).prop('id');
        ////
        //if (inputId.toString().includes("mDate") && (charCode == 8 || charCode == 46))
        //{

        //    var RowIndex = $(this).prop('id').split('-')[1];
        //    var d = $("#mDate-" + RowIndex).val();

        //    $("#mDate-" + RowIndex).val(d);

        //    //return false;
        //}


        //if (charCode != 8 && charCode != 46 && charCode != "0" && !/\d/.test(charStr)) {
        //    //return false;
        //}

    });

    // Calc Dynamic Table Total
    //
    $('#NewInvoiceTable').on('keyup', 'input', function () {

        var RowIndex = $(this).prop('id').split('-')[1];

        var debit = $("#nDebit-" + RowIndex).val();
        //
        if (debit == "" || debit == null)
        {
            debit = 0;
            $("#nDebit-" + RowIndex).val(0);
        }

        var sum = 0;
        //var count = 0;
        //$("#NewInvoiceTable").find('input[name="record"]').each(function () {


        //    if (count != RowIndex)
        //        sum += parseInt($("#nDebit-" + count).val());

        //    count++;
        //});

        $("#NewInvoiceTable").find('input[name="record"]').each(function () {

            var id = $(this).attr('id');

            if (id == null)
                return;


            var format = id.split("-");
            var val = parseInt(format[1]);

            if (val != RowIndex)
                sum += parseInt($("#nDebit-" + val).val());

        });

        sum += parseInt(debit);

        $('#installmentTotal').html(sum);

    });

    $(".add-row").click(function () {

        var rowIndex = 0;

        var paymentDay = parseInt($("#PaymentDay").val());
        var actiovationDate = $("#ActivationDate").val();
        var stringDate = "01." + actiovationDate;
        var format = stringDate.split(".");
        var lastPaymentDate = new Date(format[2], format[1] - 1, format[0]);
        lastPaymentDate.setDate(paymentDay);

        //var isValid = compareMaxIntervalAndPlanInterval();
        ////
        //if (!isValid)
        //{
        //    return;
        //}




        var count = 0;
        //
        $(".paymentPlan").find('input[name="record"]').each(function () {

            count++;
            var id = $(this).attr('id');

            if (id == null)
                return;

            var format = id.split("-");
            var val =  parseInt(format[1]);
            //
            if (val > rowIndex) {
                rowIndex = val;

                lastPaymentDate = $("#mDate-" + val).val();
            }


        });

        if(rowIndex > 0)
            rowIndex++;

        var tableRow = '<tr>';
        tableRow += '<td><input id="chk-' + rowIndex + '" type="checkbox" name="record" /></td>';
        tableRow += '<td><input type="date" name="maturityDate" id="mDate-' + rowIndex + '" placeholder="Item Name" class="form-control"></td>';
        tableRow += '<td><input type="number" name="debit[]" id="nDebit-' + rowIndex + '" placeholder="Item Price" class="form-control"></td>';
        tableRow += '</tr>';
        $('#NewInvoiceTable').append(tableRow);



        // Manually Added
        count++;


        var dTest = new Date(lastPaymentDate.toString());
        //var dTest = new Date(lastPaymentDate.getFullYear(), lastPaymentDate.getMonth(), lastPaymentDate.getDay());
        dTest.setMonth(dTest.getMonth() + 1);
        var strDate = convertDate_CorrectFormat(dTest);
        //myDate.setDate(paymentDay);

        var dateColumnName = "#mDate-" + rowIndex;
        var debitColumnName = "#nDebit-" + rowIndex;
        $(dateColumnName).val(strDate);
        $(debitColumnName).val(0);




        var amount = $("#Amount").val();
        var installment = parseInt(amount / count);
        var i = 0;
        var sum = 0;
        $(".paymentPlan").find('input[name="record"]').each(function () {

            i++;
            var id = $(this).attr('id');

            if (id == null)
                return;


            if (i == count)
                installment = amount - sum;

            sum += parseFloat(installment);

            var format = id.split("-");
            $("#nDebit-" + format[1]).val(installment);



        });

        $('#installmentTotal').html(sum);


        var planInterval = $("#planInterval").val();
        var pi = parseInt(planInterval);
        pi++;
        $("#planInterval").val(pi)

        //var markup = "<tr><td><input type='checkbox' name='record'></td><td><input type='date' name='maturityDate' class='form-control' ></td><td><input type='number' name='debit' class='form-control'></td>";
        //$(".paymentPlan").append(markup);
    });

    $(".delete-row").click(function () {


        var count = 0
        var deletedRowCount = 0;
        $(".paymentPlan").find('input[name="record"]').each(function () {


            if ($(this).is(":checked")) {
                $(this).parents("tr").remove();
                deletedRowCount++;
            }
            else {


                count++;
                //var id = $(this).attr('id');//$('#idEstablishmentRow td.ms-formbody span input').attr('id');
                //if (id == null)
                //    return;

                //var format = id.split("-");
                //var val = $("#nDebit-" + format[1]).val();
                //var newValue = parseFloat(val);

                //sum += newValue;
            }


        });

        var amount = $("#Amount").val();
        var installment = parseInt(amount / count);
        var i = 0;
        var sum = 0;
        
        $(".paymentPlan").find('input[name="record"]').each(function () {

            i++;
            var id = $(this).attr('id');

            if (id == null)
                return;


            if (i == count)
                installment = amount - sum;

            sum += parseFloat(installment);

            var format = id.split("-");
            $("#nDebit-" + format[1]).val(installment);

        });

        $('#installmentTotal').html(sum);

        var planInterval = $("#planInterval").val();
        var pi = parseInt(planInterval);
        pi -= deletedRowCount;
        $("#planInterval").val(pi)
    });


    function applicationDateChange()
    {
        var actiovationDate = $("#ApplicationDate").val();

        var format = actiovationDate.toString().split(".");
        //
        var month = parseInt(format[1]);
        var year = parseInt(format[2]);
        //
        if (month > 12) {
            month = 1;
            year++;
        }


        var myDate = new Date(year, month, 1);
        //
        var cDate = kendo.toString(kendo.parseDate(myDate), 'MM.yyyy');
        $("#ActivationDate").data("kendoDatePicker").value(cDate);

    }

    function activationDateChange() {

        var actiovationDate = $("#ActivationDate").val();
        var format = actiovationDate.split(".");
        //
        var actMonth = parseInt(format[0]);
        var actYear = parseInt(format[1]);

        var applicationDate = $("#ApplicationDate").val();

        var format2 = applicationDate.toString().split(".");
        //
        var appMonth = parseInt(format2[1]);
        var appYear = parseInt(format2[2]);

        var month = parseInt(format2[1]);
        var year = parseInt(format2[2]);
        //
        if (month > 12) {
            month = 1;
            year++;
        }

        var myDate = new Date(year, month, 1);
        //
        var cDate = kendo.toString(kendo.parseDate(myDate), 'MM.yyyy');
        if(actYear < appYear)
        {
            BootstrapDialog.alert("Ödeme Başlangıç Tarihi ile İşlem Tarihi Eşit yada Küçük Olamaz.");
            $("#ActivationDate").data("kendoDatePicker").value(cDate);

            return;
        }

        if(actYear == appYear && actMonth <= appMonth)
        {
            BootstrapDialog.alert("Ödeme Başlangıç Tarihi ile İşlem Tarihi Eşit yada Küçük Olamaz.");
            $("#ActivationDate").data("kendoDatePicker").value(cDate);

            return;
        }

    }


    function compareMaxIntervalAndPlanInterval() {

        var maxInterval = $("#maxInterval").val();
        var planInterval = $("#planInterval").val();
        var pi = parseInt(planInterval);
        var mi = parseInt(maxInterval);
        pi++;
        //
        if (pi > mi) {
            BootstrapDialog.alert("Ödeme Plan Taksit Sayısı '" + pi + "' ile Maksimum Taksit Sayısı '" + maxInterval + "' Daha Buyuk Olamaz!");
            $('#planInterval').val(maxInterval);

            return false;
        }

        return true;
    }


    function convertDate_CorrectFormat(inputFormat) {
        function pad(s) { return (s < 10) ? '0' + s : s; }

        var year = inputFormat.getFullYear();
        var month = pad(inputFormat.getMonth() + 1);
        var day = pad(inputFormat.getDate());
        var calcDate = [year, month, day].join('-');
        return calcDate;
    }


    function convertDate(inputFormat) {
        function pad(s) { return (s < 10) ? '0' + s : s; }
        var d = new Date(inputFormat);

        var year = d.getFullYear();
        var month = pad(d.getMonth() + 1);
        var day = pad(d.getDate());
        var calcDate = [year, month, day].join('-');
        return calcDate;
    }


</script>
